    INCLUDE "defines.inc"

    dc.l $0010F300,$00C00402,$00C00408,$00C0040E
    dc.l $00C00414,$00C0041A,$00C0041A,$00C0041A
    dc.l $00C0041A,$00C00420,$00C00426,$00C00426
    dc.l $00C00426,$00C00426,$00C00426,$00C0042C
    dc.l $00C00426,$00C00426,$00C00426,$00C00426
    dc.l $00C00426,$00C00426,$00C00426,$00C00426
    dc.l $00C00432,   VBlank,     Irq2,$00000000
    dc.l $00000000,$00000000,$00000000,$00000000
    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF

    dc.b "NEO-GEO", $00
    dc.w $0202, $0010, $0000, $0010

    dc.w $0000, $0100, $0000, $0000 
    dc.w $0E54, $0000, $0FD0, $0000 

    dc.w $114C

    jmp     Start
    jmp     Start2
    jmp     Start3

    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF

    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF

    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF

    dc.w $0000

    dc.l $00000186

    dc.l $76004A6D,$0A146600,$003C206D,$0A043E2D
    dc.l $0A0813C0,$00300001,$32100C01,$00FF671A
    dc.l $30280002,$B02D0ACE,$66103028,$0004B02D
    dc.l $0ACF6606,$B22D0AD0,$67085088,$51CFFFD4
    dc.l $36074E75,$206D0A04,$3E2D0A08,$3210E049
    dc.l $0C0100FF,$671A3010,$B02D0ACE,$66123028
    dc.l $0002E048,$B02D0ACF,$6606B22D,$0AD06708
    dc.l $588851CF,$FFD83607
    dc.w $4e75

VBlank:
    btst    #7, $10fd80
    bne     DisplayedLogo

    move.l  #$c00438, a0
    jmp     (a0)

DisplayedLogo:
    move.w  #4, $3c000c
    move.b  d0, $300001

    move.b  #1, VertBlank

    rte

Irq2:
    rte

Start:
    jsr     Setup

    lea     Message, a2
    move.w  #15, d1
    move.w  #36, d0

    move.w  #1, d3             ; X Position of 10
    asl.l   #5, d3              
    add.w   #10, d3            ; Y Position
    add.w   #$7000, d3         ; Sprite Offset    
    move.w  d3, d4
    move.w  #$0000, d6

MessageOuterLoop:
MessageInnerLoop:
    move.w  d3, $3c0000
    move.w  #$32e0, d7          ; Palette number 
    move.b  (a2)+, d6
    add.w   d6, d7
    move.w  d7, $3c0002
    add.l   #$20, d3
    dbra    d0, MessageInnerLoop
    move.w  #36, d0
    addq    #1, d4
    move.l  d4, d3
    dbra    d1, MessageOuterLoop

    lea     Members, a2
    move.w  #3, d1
    move.w  #36, d0

    add.w   #1, d4
    move.l  d4, d3

MembersOuterLoop:
MembersInnerLoop:
    move.w  d3, $3c0000
    move.w  #$32e0, d7          ; Palette number 
    move.b  (a2)+, d6
    add.w   d6, d7
    move.w  d7, $3c0002
    add.l   #$20, d3
    dbra    d0, MembersInnerLoop
    move.w  #36, d0
    addq    #1, d4
    move.l  d4, d3
    dbra    d1, MembersOuterLoop

    move.w  #$8010, $3c0000
    move.w  #$200,  $3c0004
    move.w  #$0fff, $3c0002
    move.w  #$fc0e, $3c0002     ; Normally $f80e
    move.w  #$440, $3c0002

    move.w  #$8011, d1
    move.w  #18, d0

SpriteMapLoop:
    move.w  d1, $3c0000
    move.w  #$0fff, $3c0002
    move.w  #$40, $3c0002
    add.w   #1, d1
    dbra    d0, SpriteMapLoop

    move.w  #$1, $3c0004
    lea     ChaosMap, a5
    move.w  #$0400, a0
    move.w  a0, a1

    move.w  #3, d4

ChaosOuterLoop:
    move.w  #19, d5

ChaosInnerLoop:
    move.w  a0, $3c0000
    move.w  (a5)+, $3c0002
    move.w  #$0000, $3c0002
    add.w   #64, a0     
    dbra.w  d5, ChaosInnerLoop

    add.w   #2, a1
    move.w  a1, a0

    dbra.w  d4, ChaosOuterLoop

    lea     TilesMap, a5

    move.w  #11, d4

TilesOuterLoop:
    move.w  #18, d5

TilesInnerLoop:
    move.w  a0, $3c0000
    move.w  (a5)+, $3c0002
    move.w  #$0100, $3c0002
    add.w   #64, a0     
    dbra.w  d5, TilesInnerLoop

    add.w   #2, a1
    move.w  a1, a0

    dbra.w  d4, TilesOuterLoop

    move.w  #$8100, $3c0000
    move.w  #$200,  $3c0004
    move.w  #$0FFF, $3c0002
    move.w  #$F20E, $3c0002     ; Normally $f80e
    move.w  #$2800, $3c0002

    move.w  #$8101, d1
    move.w  #8, d0

MovingMapLoop:
    move.w  d1, $3c0000
    move.w  #$0FFF, $3c0002
    move.w  #$40, $3c0002
    add.w   #1, d1
    dbra    d0, MovingMapLoop

    move.w  #$1,  $3c0004

    move.w  #$4000, a0

    move.w  #157, d0
    move.w  #167, d1

    move.w  #9, d5

MovingLoop:
    move.w  a0, $3c0000

    move.w  d0, $3c0002
    move.w  #$0200, $3c0002

    add.w   #1, d0

    move.w  d1, $3c0002
    move.w  #$0200, $3c0002

    add.w   #1, d1

    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    add.w   #$40, a0

    dbra.w  d5, MovingLoop

    move.b  #0, VertBlank
    move.b  #0, Direction
    move.b  #0, Flip

    move.w  #$2000, sr

Loop:
    cmp.b   #1, VertBlank    
    bne     Loop

    move.b  $300000, d0
    not.b   d0

    btst    #2, d0
    beq     NotLeft

    move.w  #$8500, $3c0000
    move.w  $3c0002, d1

    cmp.w   #128, d1        ; 1 * 128
    ble     EndInput

    sub.w   #128, d1

    move.w  #$8500, $3c0000
    move.w  d1, $3c0002

    bra     EndInput

NotLeft:
    btst    #3, d0
    beq     EndInput

    move.w  #$8500, $3c0000
    move.w  $3c0002, d1

    cmp.w   #20480, d1  ; 160 * 128
    bge     EndInput

    add.w   #128, d1

    move.w  #$8500, $3c0000
    move.w  d1, $3c0002

EndInput:
    move.b  #0, VertBlank   

    cmp.b   #1, Direction
    beq     GoingDown
    
    move.w  #$8100, $3c0000
    move.w  $3c0002, d1
    move.w  d1, d3
    and.w   #$00ff, d1
    and.w   #$ff00, d3

    cmp.w   #$00, d1
    beq     ResetDown

    sub.w   #$0f, d1

    move.w  #$8100, $3c0000

    or.w    d3, d1
    move.w  d1, $3c0002

    move.w  #$8300, $3c0000
    move.w  $3c0002, d1

    sub.w   #128, d1 

    move.w  #$8300, $3c0000
    move.w  d1, $3c0002

    jmp     Repeat

ResetDown:
    move.b  #1, Direction
    move.w  #$8100, $3c0000

    or.w    d3, d1
    move.w  d1, $3c0002

    jsr     FlipLogo

    jmp     Repeat

GoingDown:
    move.w  #$8100, $3c0000
    move.w  $3c0002, d1
    move.w  d1, d3
    and.w   #$00ff, d1
    and.w   #$ff00, d3

    cmp.w   #$FF, d1
    beq     ResetUp

    add.w   #$0f, d1

    move.w  #$8100, $3c0000

    or.w    d3, d1
    move.w  d1, $3c0002

    move.w  #$8300, $3c0000
    move.w  $3c0002, d1

    add.w   #128, d1 

    move.w  #$8300, $3c0000
    move.w  d1, $3c0002

    jmp     Repeat

ResetUp:
    move.b  #0, Direction
    move.w  #$8100, $3c0000

    or.w    d3, d1
    move.w  d1, $3c0002

Repeat:
    bra     Loop

Start2:
    rts

Start3:
    rts

Setup:
    move.w  #0, $3c0006
    move.w  #7, $3c000c

    jsr     SetupPalette

    move.l  #$c004c2, a0
    jsr     (a0)

    movem.l d0-d6, -(a7)

    move.w  #$7000, d0
    move.w  #$701f, d1
    move.w  #$7001, d4
    move.w  #$701e, d5
    move.w  #$20, d2
    move.w  #$20, d3
    move.w  #$27, d7

SetupLoop:
    move.w  d0, $3c0000
    nop
    move.w  d2, $3c0002
    nop
    move.w  d1, $3c0000
    nop
    move.w  d2, $3c0002
    nop
    move.w  d4, $3c0000
    nop
    move.w  d2, $3c0002
    nop
    move.w  d5, $3c0000
    nop
    move.w  d2, $3c0002
    nop
    add.w   d3, d0
    add.w   d3, d1
    add.w   d3, d4
    add.w   d3, d5
    dbra    d7, SetupLoop

    movem.l (a7)+, d0-d6

    move.l  #$c004c8, a0
    jsr     (a0)

    rts

SetupPalette:
    lea     $400000, a0
    lea     Palettes, a1
    move.w  #PalettesSize, d7
    asr.w   #5, d7

DoPalette:
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    dbra    d7, DoPalette

    rts

FlipLogo:
    move.w  #1, $3c0004

    move.w  #$4000, a0
    move.w  #9, d5

    move.b  Flip, d0
    add.b   #1, d0
    and.b   #1, d0
    move.b  d0, Flip

    cmp.b   #1, d0
    bne     Normal

    move.w  #167, d0
    move.w  #157, d1
    move.w  #$0202,d2

    jmp     FlipLoop

Normal:
    move.w  #157, d0
    move.w  #167, d1
    move.w  #$0200,d2
    
FlipLoop:
    move.w  a0, $3c0000

    move.w  d0, $3c0002
    move.w  d2, $3c0002

    add.w   #1, d0

    move.w  d1, $3c0002
    move.w  d2, $3c0002

    add.w   #1, d1

    add.w   #$40, a0

    dbra    d5, FlipLoop

    rts

;            *        1         2         3     *
;           0123456789012345678901234567890123456
Message:
    dc.b   "   WELCOME TO THE 10TH ANNIVERSARY   "
    dc.b   " CHAOS DEMO, AND FIRST EVER NEOGEO   "
    dc.b   " DEMO. THIS THE SECOND CHAOS DEMO ON "
    dc.b   " AN ARCADE GAME SYSTEM. THE CPS-1    "
    dc.b   " SYSTEM IS THE NEXT PLANNED SYSTEM TO"
    dc.b   " BE BLESSED WITH A CHAOS RELEASE. :) "
    dc.b   "                                     "
    dc.b   " NOW TO GET A HOLD OF A JAMMA RIG TO "
    dc.b   " TEST THE DEMOS ON A REAL SYSTEM.    "
    dc.b   "                                     "
    dc.b   " EVENTUALLY WE RE PLANNING ON DOING  "
    dc.b   " SOME REAL ARCADE GAMES.             "
    dc.b   "                                     "
    dc.b   " CONTACT RASTER AT CDOTY@NETZERO.NET "
    dc.b   "                                     "
    dc.b   " LONG LIVE POOPER*****CODED BY RASTER"

Members:
    dc.b   "              MEMBERS:               " 
    dc.b   "     RASTER            PICKSTER      "
    dc.b   "           SECTOR SMASHER            "

SpriteNumber:
    dc.w 14

Palettes:
    INCBIN "chaos.pal"
    INCBIN "tiles.pal"
    INCBIN "sprite.pal"
    dc.w   $0000,$000C,$7FFF,$0000,$0000,$0000,$0000,$0000
    dc.w   $0000,$7FFF,$000C,$0000,$0000,$0000,$0000,$0000
EndPalettes:
    PalettesSize size EndPalettes-Palettes

ChaosMap:
    INCBIN "chaos.mp1"
ChaosMapEnd:
    ChaosMapSize size ChaosMapEnd-ChaosMap

TilesMap:
    INCBIN "tiles.mp1"
TilesMapEnd:
    TilesMapSize size TilesMapEnd-TilesMap
